/**
 * JASMINe
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: DisconnectTopicCommand.as 4798 2009-08-07 12:30:47Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.quickvisu.cairngorm.command
{
import com.adobe.cairngorm.commands.ICommand;
import com.adobe.cairngorm.control.CairngormEvent;

import mx.controls.Alert;
import mx.rpc.IResponder;
import mx.rpc.events.FaultEvent;
import mx.rpc.events.ResultEvent;

import org.ow2.jasmine.monitoring.eos.quickvisu.cairngorm.business.IDisconnectTopicDelegate;
import org.ow2.jasmine.monitoring.eos.quickvisu.cairngorm.model.QuickVisuModelLocator;

/**
 * @author Guillaume Renault
 */
public class DisconnectTopicCommand implements ICommand, IResponder
{

    public function execute(event:CairngormEvent):void
    {
        var delegate:IDisconnectTopicDelegate = QuickVisuModelLocator.getInstance().getDisconnectTopicDelegate();
        delegate.responder = this;
        delegate.disconnect();
    }

    public function result(data:Object):void
    {
        var model:QuickVisuModelLocator = QuickVisuModelLocator.getInstance();
        model.connect = (data as ResultEvent).result as int;
        model.state = QuickVisuModelLocator.DISCONNECTED;
    }

    public function fault(event:Object):void
    {
        var faultEvent : FaultEvent = FaultEvent( event );
        Alert.show( "Error during the attempt to disconnect to the JMS topic : Unhandled error","Error" );
    }

}
}
